--- old/usr/src/uts/common/os/watchpoint.c	2015-05-08 18:10:31.618637076 -0400
+++ new/usr/src/uts/common/os/watchpoint.c	2015-05-08 18:10:31.625463448 -0400
@@ -182,11 +182,7 @@
 	/*
 	 * as->a_wpage can only be changed while the process is totally stopped.
 	 * Don't grab p_lock here.  Holding p_lock while grabbing the address
-	 * space lock leads to deadlocks with the clock thread.  Note that if an
-	 * as_fault() is servicing a fault to a watched page on behalf of an
-	 * XHAT provider, watchpoint will be temporarily cleared (and wp_prot
-	 * will be set to wp_oprot).  Since this is done while holding as writer
-	 * lock, we need to grab as lock (reader lock is good enough).
+	 * space lock leads to deadlocks with the clock thread.
 	 *
 	 * p_maplock prevents simultaneous execution of this function.  Under
 	 * normal circumstances, holdwatch() will stop all other threads, so the
@@ -311,9 +307,9 @@
 		retry:
 			seg = as_segat(as, addr);
 			ASSERT(seg != NULL);
-			SEGOP_GETPROT(seg, addr, 0, &oprot);
+			segop_getprot(seg, addr, 0, &oprot);
 			if (prot != oprot) {
-				err = SEGOP_SETPROT(seg, addr, PAGESIZE, prot);
+				err = segop_setprot(seg, addr, PAGESIZE, prot);
 				if (err == IE_RETRY) {
 					ASSERT(retrycnt == 0);
 					retrycnt++;
@@ -406,7 +402,7 @@
 		if ((seg = as_segat(as, vaddr)) != NULL &&
 		    !(pwp->wp_flags & WP_NOWATCH)) {
 			prot = pwp->wp_prot;
-			err = SEGOP_SETPROT(seg, vaddr, PAGESIZE, prot);
+			err = segop_setprot(seg, vaddr, PAGESIZE, prot);
 			if (err == IE_RETRY) {
 				ASSERT(retrycnt == 0);
 				retrycnt++;
@@ -504,7 +500,6 @@
 	if ((as == &kas) || avl_numnodes(&as->a_wpage) == 0)
 		return (0);
 
-	/* Grab the lock because of XHAT (see comment in pr_mappage()) */
 	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
 	rv = pr_is_watchpage_as(addr, rw, as);
 	AS_LOCK_EXIT(as, &as->a_lock);
